# -*- coding: iso-8859-2 -*-
"""
Nazwa: EKG-Spim
Licencja: GPL

Autorzy:
DevNull (devnull2 at o2 dot pl)
mi_shell (mi_shell at o2 dot pl)


wymagane  ustawienia w ekg:
alias -a >>ekg-spim /^msg >>ekg-spim %1
bind -a F8 >>ekg-spim wo

"""

import ekg
import string, os
from time import strftime, localtime

app_name = ">>ekg-spim"
ver = "0.1alpha :P"

#Nazwa pliku zawierajacego 'zakazane' wyrazy
spim_list_file = "ekg-spim.list"

#Nazwa pliku zawierajaca otrzymane lancuszki
spim_log_file = "ekg-spim.log"

#lista zakazanych wyrazow
spim_list = []

#Zmienna wykorzysywana do obslugi polecen w skrypcie
wait_opt = 0 

#Security level, liczba okreslajaca poziom filtrowania lancuszkow
slevel = 2

#Tresc wysylanej wiadomosci do nadawcy lancuszka
MSG_NO_SPIM = "[EKG-Spim] !! Twoja wiadomosc zostala zakwalifikowana jako lancuszek !!"
MSG_DEF_SPIM = """
"acuszek rozsyany do wszystkich znajomych, a przez nich do wszystkich znajomych, w relatywnie bardzo krtkim czasie egzystuje w sieci w milionach egzemplarzy. Prowadzi to do oczywistych efektw - zapchanie cz internetowych, blokada serwerw oraz wszystkie inne negatywne skutki jakie niesie ze sob spam, ktrego acuszki s jedn z form.
Poza tym, autorzy lancuszkow staraj si uderzy w czu strun kadego czowieka, ktry odbiera tak faszyw wiadomo, a tym samym wykorzysta jego uczuciowo i ch niesienia pomocy. Jeli tworz zawiadomienie o groznym wirusie, to wykorzystuj nasz ch powiadomienia innych o niebezpieczestwie - ktre praktycznie zawsze okazuje si faszywe. Tak samo, gdy prosz o pomoc w szukaniu krwi, czy zebraniu pienidzy dla ratowania czyjego ludzkiego ycia. Uwiadomienie sobie, do jak delikatnych i prywatnych aspektw ycia docieraj twrcy tego typu listw, tylko i wycznie dla wasnej satysfakcji, powinno wyranie uczula z jak nagannym zjawiskiem mamy do czynienia.
Czsto wykorzystywanym motywem jest naturalny odruch czowieka konsumpcyjnego do uzyskania czego za darmo. Dlatego te, ostatnimi czasy plag stay si (oczywicie faszywe) informacje o tym, e rozesanie e-maili do 10, 20 czy 30 odbiorcw owocuje otrzymaniem darmowego telefonu komrkowego. acuszki s bardzo negatywn form komunikacji. Dua cz spoecznoci Internetu uwaa za swj obowizek przesanie takiego listu do wszystkich swoich znajomych - a o to wanie twrcom chodzi. O wygenerowanie jak najwikszego ruchu w sieci, dla zablokowania lub przynajmniej maksymalnego obcienia jak najwikszej iloci serwerww i cz. Jest to denie do wyrzdzenia za dla samego wyrzdzania za, gdy twrcy takich acuszkow nie czerpi adnych korzyci finansowych z tej dziaalnoci.
Jedynym susznym dziaaniem w przypadku otrzymania acuszka jest jego natychmiastowe usunicie i nie przesyanie go komukolwiek innemu lub gdziekolwiek dalej!" """


def init():
    ekg.printf("generic", "EKG-Spim \x1b[32m\x1b[1m[ON]")
    
    fa = open(os.getcwd()+ "/.gg/scripts/" + spim_list_file, "r")
    while 1:
        spimf = fa.readline()
        if spimf == '':
            break
            
        if spimf != '':
            spim_list.append(spimf[:-1])
        
        else:
           ekg.printf("generic", "\x1b[31Nie znaleziono bazy wyrazow w podanej lokalizacji.\x1b[0m")
           
    fa.close()
       


def deinit():
    ekg.printf("generic", "EKG-Spim \x1b[31m\x1b[1m[OFF]")
    return 1


def handle_msg(uin, name, msgclass, text, time, secure):
    msg_p = 0
   
    if slevel > 0:
      
       if len(text) > 150: #Test1 - sprawdzenie czy wiadomosc nie jest za dluga :]
           msg_p = 1 + msg_p
       
       for x in spim_list: #Test2 - sprawdzanie "zakazanych" wyrazow
           if string.count(text,x) >= 1:
               msg_p = 1 + msg_p
    
       spec_char = "~`!@#$%^&*()_+-=[]{}\|<>?/" #Test3 - sprawdzenie wystepowania znakow specjalnych w wiadomosci
       for x in range(len(spec_char)):             
           if string.count(text,spec_char[x]) >= 10:
               msg_p = 1 + msg_p

       ekg.printf("generic", "msg_p = %d" % msg_p)

    if slevel == 1:
        if msg_p >= 40:
            ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33m(SPIM!!)\x1b[0m")
            spim_log(text, name, msg_p)
            return 0
        if msg_p >= 25:
            ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33m(SPIM!!)\x1b[0m")
            spim_log(text, name, msg_p)
            return 1

    if slevel == 2:
        if msg_p >= 25:
            ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33m(SPIM!!)\x1b[0m")
            spim_log(text, name, msg_p)
            return 0
        if msg_p >= 15:
            spim_log(text, name, msg_p)
            ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33m(SPIM!!)\x1b[0m")
            return 1

    if slevel == 3:
        if msg_p >= 15:
           ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33m(SPIM!!)\x1b[0m")
           ekg.command("/^msg %d %s" % (uin,MSG_NO_SPIM))
           spim_log(text, name, msg_p)
           return 0
        if msg_p >= 10:
           ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33m(SPIM!!)\x1b[0m")
           spim_log(text, name, msg_p)
           return 0

    if slevel == 4:
        if msg_p >= 5:
            ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33m(SPIM!!)\x1b[0m")
            ekg.command("/^msg %d %s" % (uin, MSG_NO_SPIM))
            ekg.command("/^msg %d %s" % (uin, MSG_DEF_SPIM))
            spim_log(text,name,msg_p)
            return 0
           
       

    

def handle_msg_own(rcpts, text):
    global wait_opt, app_name
    
    if rcpts == app_name:
        if text == "wo":
            wait_opt = 1
            ekg.printf("generic", "\x1b[1m>>EKG-Spim\x1b[0m")
        else:
            exec_cmd(text)
            
        return 0

    if wait_opt == 1:
        exec_cmd(text)
        wait_opt = 0
        return 0      


def exec_cmd(text):
    global slevel
    
    if text == "0":
        slevel = 0
        
        ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33mUstawiono poziom ochrony anty-spim na %d\x1b[0m" % slevel)
            
    elif text == "1":
        slevel = 1
        ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33mUstawiono poziom ochrony anty-spim na %d\x1b[0m" % slevel)

    elif text == "2":
        slevel = 2
        ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33mUstawiono poziom ochrony anty-spim na %d\x1b[0m" % slevel)

    elif text == "3":
        slevel = 3
        ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33mUstawiono poziom ochrony anty-spim na %d\x1b[0m" % slevel)

    elif text == "4":
        slevel = 4
        ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[33mUstawiono poziom ochrony anty-spim na %d\x1b[0m" % slevel)
       
    elif text == "h":
        help()
        
    else:
        ekg.printf("generic", "\x1b[1mEKG-Spim:\x1b[0m \x1b[31mBledna opcja! Nacisnij klawisz kontroli skryptu, a nastepnie wpisz\x1b[0m 'h' \x1b[31maby uzyskac pomoc.")

def spim_log(spim,nm,msgp):
    czas = strftime("%d %b %Y-%H:%M:%S", localtime())
    fl = open(os.getcwd()+ "/.gg/scripts/" + spim_log_file, "a+")
    fl.write("(%s)/%s, msg_p = %d \n" % (czas, nm, msgp))
    fl.write(spim + "\n\n")
    fl.close()


def help():
    ekg.printf("generic", "\x1b[32m.-----------------------------------------------.\x1b[0m")
    ekg.printf("generic", "\x1b[32m|\x1b[0m Sterowanie EKG-Spim - lista dostepnych opcji: \x1b[32m|\x1b[0m")
    ekg.printf("generic", "\x1b[32m`-----------------------------------------------'\x1b[0m")
    ekg.printf("generic", "")
    ekg.printf("generic", "\x1b[1m'1'\x1b[0m \x1b[31m-\x1b[0m ustawia poziom filtrowania na '1'")
    ekg.printf("generic", "\x1b[1m'2'\x1b[0m\x1b[31m -\x1b[0m ustawia poziom filtrowania na '2'")
    ekg.printf("generic", "\x1b[1m'3'\x1b[0m\x1b[31m -\x1b[0m ustawia poziom filtrowania na '3'")
    ekg.printf("generic", "\x1b[1m'4'\x1b[0m\x1b[31m -\x1b[0m ustawia poziom filtrowania na '4'")
    
    ekg.printf("generic", "\x1b[1m'h'\x1b[0m\x1b[31m -\x1b[0m wyswietla pomoc")
